 function [x, mu, xi, M, d, F, fval, exitflag] = ...
    lof1(N, eps, eg2)

% [x, mu, xi, M, d, F] = lof1(7, 0, 1);

t = -1 + 2.*rand(N,1); %linspace(-1, 1, N)';  %
F = [ones(N,1), t, t.^2, t.^3];%  [ones(N,1), t, t.^2]; % 
%F = [ones(N,1), t, t.^2]; %works when N = 6 and (linspace); sometimes (rand)
[Q,~] = qr(F);
p = size(F,2);
Q2 = Q(:,(p+1):N);

eg1 = 0;
if eg1 == 1
    alpha = .04;
    beta = sqrt(1 - alpha^2);
    Q2 = [alpha;beta];
    N=2;
    p=1;
    eps = 0;
end

%rand start doesn't always work
if (eg2)
    t = [-0.4240    0.0522    0.2069    ...
        0.3358    0.4145    0.4594    0.5628]';
    N = length(t);
    F = [ones(N,1), t, t.^2, t.^3];
    [Q,~] = qr(F);
    p = size(F,2);
    Q2 = Q(:,(p+1):N);
end

eg3 = 0;
if eg3 == 1
    Q2 = [0 0; 1 0; 0 1];
    N = 3;
    p = 1;
    eps = .001;
end

%% apply pso
fun = @(v) K(v, eps, Q2, N, p);
hybridopts = optimoptions('fmincon','Display', 'iter');
options = optimoptions('particleswarm', 'Display', 'iter');
[v,fval,exitflag,~] = particleswarm(fun, N-p+1, ...
    [-ones(N-p,1);0], [ones(N-p,1);Inf], options);
[x, mu, xi, M, d]  = H(v, eps, Q2, N, p);
checkpso = [norm(x) - 1; sum(xi) - 1; x'*M*x - mu; d - mu]

%% apply fmincon
fun = @(w) G(w, eps, Q2, N, p);
w0 = v'; %[x;mu];% [ones(N,1)/N; 2]; %
mycon = @(w)mycon0(w,eps, Q2, N, p);
[w, fval, exitflag] = fmincon(fun, w0, [], [], [], [], ...
    [], [], mycon, hybridopts);
x = w(1:(N-p));
mu = w(N-p+1);
vec = abs(Q2*x);
indi = (vec < eps*sqrt(mu));
N0 = sum(indi);  % number of eps's in result
mu = (sum(vec.*(1-indi))/(1-N0*eps))^2;
xi = max(vec/sqrt(mu),eps);
M = Q2'*diag(1./xi)*Q2;
d =  max(eig(M));
checkfmin = [norm(x) - 1; sum(xi) - 1; x'*M*x - mu; d - mu]
check2 = Q2*x

%% ============================= subfunction "H" ==========================

     function [x, mu, xi, M, d]  = H(v, eps, Q2, N, p)
         
         x = v(1:(N-p));
         s = size(x);
         if s(2) > s(1)
             x = x';
         end
         %        x = x/norm(x);
         mu = v(N-p+1);
         vec = abs(Q2*x);
         indi = (vec < eps*sqrt(mu));
         N0 = sum(indi);  % number of eps's in result
         mu = (sum(vec.*(1-indi))/(1-N0*eps))^2;
         xi = max(vec/sqrt(mu),eps);
         M = Q2'*diag(1./xi)*Q2;
         d =  max(eig(M));
         
         
         %% ============================= subfunction "K" ==========================
         
         function out = K(v, eps, Q2, N, p)
             
             [x, ~, xi, ~, d]  = H(v, eps, Q2, N, p);
             vec = [d; sum(xi) - 1; norm(x) - 1];
             out = norm(vec);
             
             %% ============================= function "G" ==========================
             
             function out = G(v, eps, Q2, N, p)
             
        [~, ~, ~, ~, d]  = H(v, eps, Q2, N, p);
        out = d; %(x'*M*x - d)^2;
%% ============================= subfunction "mycon" ==========================
             
	function [c,ceq] = mycon0(w,eps, Q2, N, p)
        x = w(1:(N-p));
        mu = w(N-p+1);
        vec = abs(Q2*x);
        indi = (vec < eps*sqrt(mu));
        N0 = sum(indi);  % number of eps's in result
        mu = (sum(vec.*(1-indi))/(1-N0*eps))^2;
        xi = max(vec/sqrt(mu),eps);
        c = [];   % Compute nonlinear inequalities at w.
        ceq = [norm(x) - 1; sum(xi) - 1];   % Compute nonlinear equalities at w.
                     
                 
                 
