 function [xi, M, d, F] = lof2(N, p, eps, eg2)

% [xi, M, d, F] = lof2(7, 3, 1e-4, 0);

t = linspace(-1, 1, N)';  %-1 + 2.*rand(N,1); %

if p==3 
    F = [ones(N,1), t, t.^2];
elseif p== 4
    F = [ones(N,1), t, t.^2, t.^3];
end

[Q,~] = qr(F);
p = size(F,2);
Q2 = Q(:,(p+1):N);


eg1 = 0;
if eg1 == 1
    alpha = .04;
    beta = sqrt(1 - alpha^2);
    Q2 = [alpha;beta];
    N=2;
    p=1;
    eps = 0;
end

if (eg2)
    t = [-0.4240    0.0522    0.2069    ...
        0.3358    0.4145    0.4594    0.5628]';
    N = length(t);
    F = [ones(N,1), t, t.^2, t.^3];
    [Q,~] = qr(F);
    p = size(F,2);
    Q2 = Q(:,(p+1):N);
end

eg3 = 0;
if eg3 == 1
    Q2 = [0 0; 1 0; 0 1];
    N = 3;
    p = 1;
    eps = .001;
end

%% apply pso
%fun = @(xi) H(xi, Q2);
%hybridopts = optimoptions('fmincon','Display', 'iter');
%options = optimoptions('particleswarm', 'Display', 'iter', ...
%    'HybridFcn', {@fmincon,hybridopts});
%[xi,~,~,~] = particleswarm(fun, N, eps*ones(N,1), ones(N,1), options);
%xi = xi'/sum(xi);

%% apply fmincon 
fun = @(xi) H(xi, Q2);
%xi0 = xi; %ones(N,1)/N; %[x;mu];%

xi0 = rand(N,1);
xi0 = xi0/sum(xi0);
%[xi, ~, exitflag] = fmincon(fun, xi0, [], [], ones(1,N), 1, ...
%    eps*ones(N,1), ones(N,1), [], hybridopts)

[xi, ~, exitflag] = fmincon(fun, xi0, [], [], ones(1,N), 1, ...
    eps*ones(N,1), ones(N,1))
M = Q2'*diag(1./xi)*Q2
d = max(eig(M))

%[X, dvec] = eig(M, 'vector')
%d = max(dvec)
%x = X(:, (dvec == d))
%       x = X(:,4)
%vec = abs(Q2*x);
%fun = @(mu) sum(max(vec/sqrt(abs(mu)), eps)) - 1;
%mu1 = fzero(fun, 2);
%mu = abs(mu1);
%xi1 = max(vec/sqrt(mu),eps);
%[xi xi1]
%checkfmin = [norm(xi - xi1); sum(xi1) - 1; d - mu]


%% ============================= subfunction "H" ==========================

     function loss  = H(xi, Q2)
         
         M = Q2'*diag(sum(xi)./xi)*Q2;
         loss =  max(eig(M));
         
         